#include <stdio.h>
#include <string.h>

#if defined LONGNAME
# include "longname.h"
#endif

#define INDENT 5

void usage()
 {
  printf("Usage: INDDIFF newfile oldfile diffile newfile' oldfile'\n");
  exit(1);
 }

void put(fp,buf)
 FILE *fp;
 char *buf;
 {
  int i0,i,j,s,t,c;
  char *ptr,*start,*buf0;

  i0=0;
  buf0=buf;
  do {
   start=NULL;
   for (ptr=buf0,i=i0,j=i0+INDENT;*ptr;ptr++) {
    if (*ptr=='\t') {
     if (start==NULL) {
      start=ptr;
      c=i;
     }
     i+=8-i%8;
     j+=8-j%8;
    }
    else if (*ptr==' ') {
     if (start==NULL) {
      start=ptr;
      c=i;
     }
     i++;
     j++;
    }
    else {
     if ((start!=NULL) && (j-i!=INDENT)) break;
     else start=NULL;
     i++;
     j++;
    }
   }
   i0=i;
   if ((start!=NULL) && (j-i!=INDENT)) {
    j=i+INDENT;
    i=c+INDENT;
    t=j/8-i/8;
    if (t) i+=8-i%8;
    if (t>1) i+=(t-1)*8;
    s=j-i;
    buf0=start+t+s;
    memmove(buf0,ptr,strlen(ptr)+1);
    memset(start,'\t',t);
    memset(start+t,' ',s);
   }
   else break;
  } while (1);
  fprintf(fp,"|%s",buf);
 }

main(argc,argv)
 int argc;
 char **argv;
 {
  FILE *fpnew,*fpold,*fpdiff,*fpnew1,*fpold1,*fpin,*fpout;
  char bufnew[256],bufold[sizeof(bufnew)],bufdiff[256],*buf,*ptr;
  int linenew=0,lineold=0,*line,n=1,l,i;
  if (argc!=6) usage();
  if ((fpnew=fopen(argv[1],"r"))==NULL) {
   printf("Unable to open file %s\n",argv[1]);
   exit(1);
  }
  if ((fpold=fopen(argv[2],"r"))==NULL) {
   printf("Unable to open file %s\n",argv[2]);
   exit(1);
  }
  if ((fpdiff=fopen(argv[3],"r"))==NULL) {
   printf("Unable to open file %s\n",argv[3]);
   exit(1);
  }
  if ((fpnew1=fopen(argv[4],"w"))==NULL) {
   printf("Unable to open file %s\n",argv[4]);
   exit(1);
  }
  if ((fpold1=fopen(argv[5],"w"))==NULL) {
   printf("Unable to open file %s\n",argv[5]);
   exit(1);
  }

  while (fgets(bufdiff,sizeof(bufdiff),fpdiff)!=NULL) {
   if ((*bufdiff==0) || (*bufdiff=='\n')) n++;
   else {
    l=strtol(bufdiff,&ptr,10);
    if ((l) && ((*ptr=='<') || (*ptr=='>'))) {
     if (*ptr=='<') {
      fpin=fpnew;
      fpout=fpnew1;
      line=&linenew;
      buf=bufnew;
     }
     else {
      fpin=fpold;
      fpout=fpold1;
      line=&lineold;
      buf=bufold;
     }
     while ((*line<l) && (fgets(buf,sizeof(bufnew),fpin)!=NULL)) {
      (*line)++;
      if (*line==l) fprintf(fpout,"%*d",INDENT-1,n);
      else fprintf(fpout,"%*s",INDENT-1,"");
      put(fpout,buf);
     }
    }
   }
  }
  for (fpin=fpnew,fpout=fpnew1,buf=bufnew,i=1;i<=2;i++,fpin=fpold,fpout=fpold1,buf=bufold)
   while (fgets(buf,sizeof(bufnew),fpin)!=NULL) {
    fprintf(fpout,"%*s",INDENT-1,"");
    put(fpout,buf);
   }
  return(0);
 }